function K2BNumericSlider() {
  this.control = null;
  this.data = null;

  this.MinValue = 0;
  this.MaxValue = 0;
  this.Step = 0;

  this.SetMin = function (v) {
    this.MinValue = v;
    if (this.control != null) this.control.min = v;
  };
  this.SetMax = function (v) {
    this.MaxValue = v;
    if (this.control != null) this.control.max = v;
  };
  this.SetStep = function (v) {
    this.Step = v;
    if (this.control != null) this.control.step = v;
  };

  // Databinding for property Attribute
  this.SetAttribute = function (data) {
    ///UserCodeRegionStart:[SetAttribute] (do not remove this comment.)
    if (this.control != null) this.control.value = data;
    this.data = data;
    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  // Databinding for property Attribute
  this.GetAttribute = function () {
    ///UserCodeRegionStart:[GetAttribute] (do not remove this comment.)
    return this.data;

    ///UserCodeRegionEnd: (do not remove this comment.)
  };

  this.show = function () {
    var uc = this;
    var container = document.getElementById(this.ContainerName);
    if (this.control == null || this.control.length === 0) {
      // Only create control once
      this.control = document.createElement('k2bt-numeric-slider');
      this.control.value = this.data;

      this.control.addEventListener('input', function () {
        uc.SetAttribute(uc.control.value);

        uc.oninput();
      });

      this.control.addEventListener('change', this.onchange.closure(this));

      this.control.addEventListener('change', function () {
        if (uc.ControlValueChanged) {
          uc.ControlValueChanged();
        }
      });

      container.appendChild(this.control);
    }
    this.control.step = this.Step;
    this.control.max = this.MaxValue;
    this.control.min = this.MinValue;
    this.control.enabled = this.Enabled;
    this.control.numbervisible = this.NumberVisible;
    this.control.numberreadonly = this.NumberReadonly;
    this.control.numberclass = this.NumberClass;
    this.control.sliderclass = this.SliderClass;
    this.control.readonlyclass = this.NumberClass.split(' ')
      .map(s => 'Readonly' + s + ' ' + s)
      .join(' ');
    k2btools.updateFormControlVisibility(container, this.Visible);
  };
}
